Attribute VB_Name = "MdlHookToolTips"
Option Explicit
Private Declare Function MoveWindow Lib "user32.dll" (ByVal hwnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function SetWindowsHookEx Lib "user32" Alias "SetWindowsHookExA" (ByVal idHook As Long, ByVal lpfn As Long, ByVal hmod As Long, ByVal dwThreadId As Long) As Long
Private Declare Function UnhookWindowsHookEx Lib "user32" (ByVal hHook As Long) As Long
Private Declare Function CallNextHookEx Lib "user32" (ByVal hHook As Long, ByVal ncode As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function BeginPaint Lib "user32.dll" (ByVal hwnd As Long, ByRef lpPaint As PAINTSTRUCT) As Long
Private Declare Function EndPaint Lib "user32.dll" (ByVal hwnd As Long, ByRef lpPaint As PAINTSTRUCT) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Private Declare Function EnumWindows Lib "user32.dll" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hwnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Private Declare Function DrawText Lib "user32.dll" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, ByRef lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32.dll" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function Rectangle Lib "gdi32.dll" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CreatePen Lib "gdi32.dll" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32.dll" (ByVal crColor As Long) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function SetBkMode Lib "gdi32.dll" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function SetTextColor Lib "gdi32.dll" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal H As Long, ByVal W As Long, ByVal E As Long, ByVal O As Long, ByVal W As Long, ByVal i As Long, ByVal u As Long, ByVal S As Long, ByVal C As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal F As String) As Long
Private Declare Function MulDiv Lib "kernel32.dll" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long
Private Declare Function lstrcpy Lib "KERNEL32" Alias "lstrcpyA" (ByVal lpString1 As String, ByVal lpString2 As Long) As Long
Private Declare Function lstrlen Lib "KERNEL32" Alias "lstrlenA" (ByVal lpString As Any) As Long
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, lColorRef As Long) As Long

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type PAINTSTRUCT
    hdc As Long
    fErase As Long
    rcPaint As RECT
    fRestore As Long
    fIncUpdate As Long
    rgbReserved As Byte
End Type

Private Type CWPSTRUCT
    lParam As Long
    wParam As Long
    message As Long
    hwnd As Long
End Type

Public Enum HookConstants
    HC_ACTION = 0
    HC_GETNEXT = 1
    HC_SKIP = 2
    HC_NOREMOVE = 3
    HC_NOREM = HC_NOREMOVE
    HC_SYSMODALOFF = 5
    HC_SYSMODALON = 4
End Enum

Private Const GWL_HINSTANCE As Long = -6
Private Const GWL_WNDPROC  As Long = (-4)
Private Const GWL_STYLE As Long = -16
Private Const GWL_EXSTYLE As Long = -20
Private Const WS_BORDER As Long = &H800000
Private Const WM_SETTEXT As Long = &HC
Private Const WM_WINDOWPOSCHANGING As Long = &H46
Private Const WM_WINDOWPOSCHANGED As Long = &H47
Private Const WM_CREATE = &H1
Private Const WM_MOVE As Long = &H3
Private Const WM_PAINT As Long = &HF&
Private Const DT_CENTER As Long = &H1
Private Const DT_CALCRECT As Long = &H400
Private Const DT_VCENTER As Long = &H4
Private Const DT_SINGLELINE As Long = &H20
Private Const TRANSPARENT As Long = 1
Private Const LOGPIXELSY As Long = 90
Private Const LOGPIXELSX As Long = 88
Private Const WH_CALLWNDPROC = 4
Private Const NONANTIALIASED_QUALITY = 3
Private Const ANTIALIASED_QUALITY = 4
Private Const CLEARTYPE_QUALITY = 5

    
Dim hBrush As Long
Dim hPen As Long
Dim hFont As Long
Dim m_Text As String
Dim mForeColor As OLE_COLOR
Dim PrevProc As Long
Dim m_hwnd As Long
Dim hHook As Long

Public Property Let BackColor(ByVal oColor As OLE_COLOR)
    If hBrush Then DeleteObject hBrush
    OleTranslateColor oColor, 0, oColor
    hBrush = CreateSolidBrush(oColor)
End Property

Public Property Let BorderColor(ByVal oColor As OLE_COLOR)
    If hPen Then DeleteObject hPen
    OleTranslateColor oColor, 0, oColor
    hPen = CreatePen(0, 1, oColor)
End Property

Public Property Let ForeColor(ByVal oColor As OLE_COLOR)
    OleTranslateColor oColor, 0, mForeColor
End Property

Public Function SetFont(ByVal Name As String, ByVal Size As Integer, Optional Bold As Boolean)
    Dim hdc As Long
    Dim nHeight As Long
    
    If hFont Then DeleteObject hFont
    hdc = GetDC(0)
    nHeight = -MulDiv(Size, GetDeviceCaps(hdc, LOGPIXELSY), 72)
    ReleaseDC 0&, hdc
    
    hFont = CreateFont(nHeight, 0, 0, 0, IIf(Bold, 700, 400), 0, 0, 0, 0, 0, 0, CLEARTYPE_QUALITY, 0, Name)
End Function

Public Sub HookToolTips()

    If m_hwnd Then Exit Sub
    
    Call EnumWindows(AddressOf EnumWindowProc, &H0)

    If hBrush = 0 Then hBrush = CreateSolidBrush(&H2B2B2B)
    If hPen = 0 Then hPen = CreatePen(0, 1, &H767676)
    If hFont = 0 Then SetFont "Segoe UI", 10
        
    If m_hwnd Then
        PrevProc = SetWindowLong(m_hwnd, GWL_WNDPROC, AddressOf WindowProc)
        SetWindowLong m_hwnd, GWL_STYLE, GetWindowLong(m_hwnd, GWL_STYLE) And Not WS_BORDER
    End If
        
    If PrevProc = 0 Then
        hHook = SetWindowsHookEx(WH_CALLWNDPROC, AddressOf HookProc, 0, App.ThreadID)
    End If
End Sub
  
Public Sub UnHookToolTips()
    SetWindowLong m_hwnd, GWL_WNDPROC, PrevProc
    If hBrush Then DeleteObject hBrush: hBrush = 0
    If hPen Then DeleteObject hPen: hPen = 0
    If hFont Then DeleteObject hFont: hFont = 0
    EndHooking
    m_hwnd = 0
End Sub

Private Function EnumWindowProc(ByVal hwnd As Long, ByVal lParam As Long) As Long
    Dim sClsName As String, lPos As Long
    sClsName = Space$(100)
    
    Call GetClassName(hwnd, sClsName, 100)
    lPos = InStr(sClsName, Chr$(0))
    sClsName = Left$(sClsName, lPos - 1)
    If sClsName = "VBBubbleRT6" Or sClsName = "VBBubble" Then
        If GetWindowLong(hwnd, GWL_HINSTANCE) = App.hInstance Then
            m_hwnd = hwnd
        
            Exit Function
        End If
    End If
    
   EnumWindowProc = 1
End Function
  
Private Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim RC As RECT, DC As Long
    Dim OldFont As Long, OldBrush As Long, OldPen As Long
    Dim nScale As Long
    
    If uMsg = WM_MOVE Then
        Dim X As Long, Y As Long
        Dim W As Long, H As Long
        nScale = GetWindowsDPI
        DC = GetDC(hwnd)
        OldFont = SelectObject(DC, hFont)
        DrawText DC, m_Text, -1, RC, DT_CENTER Or DT_VCENTER Or DT_SINGLELINE Or DT_CALCRECT
        Call SelectObject(DC, OldFont)
        X = LoWord(lParam)
        Y = HiWord(lParam)
        W = RC.Right + 20 * nScale
        H = RC.Bottom + 20 * nScale
        If X + W > Screen.Width / Screen.TwipsPerPixelX Then
           X = Screen.Width / Screen.TwipsPerPixelX - W
        End If
        If Y + H > Screen.Height / Screen.TwipsPerPixelY Then
            Y = Screen.Height / Screen.TwipsPerPixelY - W
        End If
        WindowProc = CallWindowProc(PrevProc, hwnd, uMsg, wParam, lParam)
        MoveWindow hwnd, X, Y, W, H, 0
        Exit Function
    End If

    If uMsg = WM_PAINT Then
        Dim PS As PAINTSTRUCT

        BeginPaint hwnd, PS
        
        OldBrush = SelectObject(PS.hdc, hBrush)
        OldPen = SelectObject(PS.hdc, hPen)
        Rectangle PS.hdc, 0, 0, PS.rcPaint.Right, PS.rcPaint.Bottom
        SelectObject PS.hdc, OldBrush
        SelectObject PS.hdc, OldPen
        
        OldFont = SelectObject(PS.hdc, hFont)
        SetTextColor PS.hdc, mForeColor
        SetBkMode PS.hdc, 1
        DrawText PS.hdc, m_Text, -1, PS.rcPaint, DT_CENTER Or DT_VCENTER Or DT_SINGLELINE
        Call SelectObject(PS.hdc, OldFont)
        
        EndPaint hwnd, PS
    End If
    
    If uMsg = WM_SETTEXT Then
        m_Text = String$(lstrlen(ByVal lParam), 0)
        
        Call lstrcpy(ByVal m_Text, ByVal lParam)
    End If
       
    WindowProc = CallWindowProc(PrevProc, hwnd, uMsg, wParam, lParam)
    '
End Function

Public Function HookProc(ByVal uCode As Long, ByVal wParam As Long, lParam As CWPSTRUCT) As Long

On Local Error Resume Next

  HookProc = CallNextHookEx(hHook, uCode, wParam, lParam)

    If uCode = HC_ACTION Then
        If lParam.message = WM_CREATE Then
            Dim sClsName As String, lPos As Long
            sClsName = Space$(100)
            
            Call GetClassName(lParam.hwnd, sClsName, 100)
            lPos = InStr(sClsName, Chr$(0))
            sClsName = Left$(sClsName, lPos - 1)
            If sClsName = "VBBubbleRT6" Or sClsName = "VBBubble" Then
                m_hwnd = lParam.hwnd
                PrevProc = SetWindowLong(m_hwnd, GWL_WNDPROC, AddressOf WindowProc)
                SetWindowLong m_hwnd, GWL_STYLE, GetWindowLong(m_hwnd, GWL_STYLE) And Not WS_BORDER
                EndHooking
            End If
        End If
    End If
End Function

Public Sub EndHooking()
    If hHook <> 0 Then
        UnhookWindowsHookEx hHook
        hHook = 0
    End If
End Sub

Private Function LoWord(ByVal Numero As Long) As Long
    LoWord = Numero And &HFFFF&
End Function

Private Function HiWord(ByVal Numero As Long) As Long
    HiWord = Numero \ &H10000 And &HFFFF&
End Function

Public Function MakeDWord(ByVal LoWord As Integer, ByVal HiWord As Integer) As Long
  MakeDWord = (CLng(HiWord) * &H10000) Or (LoWord And &HFFFF&)
End Function

Public Function GetWindowsDPI() As Double
    Dim hdc As Long, LPX  As Double
    hdc = GetDC(0)
    LPX = CDbl(GetDeviceCaps(hdc, LOGPIXELSX))
    ReleaseDC 0, hdc

    If (LPX = 0) Then
        GetWindowsDPI = 1#
    Else
        GetWindowsDPI = LPX / 96#
    End If
End Function
